----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:52:05 03/27/2017 
-- Design Name: 
-- Module Name:    negedge - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity negedge is
    Port ( ttc_clk_in : in  STD_LOGIC;
           rx_clk_in : in  STD_LOGIC;
           ttc_clk_io : inout  STD_LOGIC_VECTOR (1 downto 0);
           gol_negedge : out  STD_LOGIC);
end negedge;

architecture Behavioral of negedge is
signal rx_clk : std_logic := '0';
signal rx_clk_dcm : std_logic := '0';
signal rx_clk90 : std_logic := '0';
signal rx_clk90_dcm : std_logic := '0';
signal rx_clk180 : std_logic := '0';
signal rx_clk270 : std_logic := '0';
signal TTC_toggle : std_logic := '0';
signal locked : std_logic := '0';
signal ttc_clk_dcm :std_logic := '0';
signal ttc_clk :std_logic := '0';
signal ttc_clk_n :std_logic := '0';
signal ttc_clk0 :std_logic := '0';
signal ttc_clk90 :std_logic := '0';
signal ttc_clk180 :std_logic := '0';
signal ttc_clk270 :std_logic := '0';
signal lock_cntr :std_logic_vector(4 downto 0) := (others => '0');
signal TTC_toggle_q :std_logic_vector(1 downto 0) := (others => '0');

begin
i_dcm_ttc: dcm
	port map	
         ( CLKIN   => ttc_clk_in ,
           CLKFB   => ttc_clk ,
           RST     => '0' ,
           DSSEN   => '0' ,
           PSINCDEC=> '0' ,
           PSEN    => '0' ,
           PSCLK   => '0' ,
			  CLK0    => ttc_clk_dcm ,
			  STATUS  => open ,
			  LOCKED  => open);
bufg_clk: bufg port map(o => ttc_clk, i => ttc_clk_dcm);
i_dcm_rx: dcm
   generic map(CLKOUT_PHASE_SHIFT => "FIXED",
-- starting phase shift after reset
--					PHASE_SHIFT => 39)
					PHASE_SHIFT => 0)
	port map	
         ( CLKIN   => rx_clk_in ,
           CLKFB   => rx_clk ,
           RST     => '0' ,
           DSSEN   => '0' ,
           PSINCDEC=> '0' ,
           PSEN    => '0' ,
           PSCLK   => '0' ,
			  CLK0    => rx_clk_dcm ,
			  CLK90    => rx_clk90_dcm ,
			  PSDONE  => open ,
			  STATUS  => open ,
			  LOCKED  => locked);
bufg_rx_clk: bufg port map(o => rx_clk, i => rx_clk_dcm);
bufg_rx_clk90: bufg port map(o => rx_clk90, i => rx_clk90_dcm);
process(rx_clk,locked)
begin
	if(locked = '0')then
		lock_cntr <= (others => '0');
  elsif(rx_clk'event and rx_clk = '1')then
		if(lock_cntr(4) = '0')then
			lock_cntr <= lock_cntr + 1;
		end if;
  end if;
end process;
process(rx_clk)
begin
  if(rx_clk'event and rx_clk = '0')then
		if(lock_cntr(4) = '0')then
			GOL_negedge <= (ttc_clk270 xor ttc_clk0) or (ttc_clk90 xor ttc_clk0);
		end if;
  end if;
end process;
process(ttc_clk)
begin
  if(ttc_clk'event and ttc_clk = '1')then
		TTC_toggle <= not TTC_toggle;
		TTC_toggle_q <= TTC_toggle & TTC_toggle;
  end if;
end process;

i_TTC_clk_DDR_out0 : OBUF port map(i => TTC_toggle_q(0), o => TTC_clk_IO(0));
i_TTC_clk_DDR_out1 : OBUF port map(i => TTC_toggle_q(1), o => TTC_clk_IO(1));
--i_TTC_clk_DDR_out0 : OFDDRRSE
--   port map (
--      Q => TTC_clk_IO(0),      -- Data output (connect directly to top-level port)
--      C0 => ttc_clk,    -- 0 degree clock input
--      C1 => ttc_clk_n,    -- 180 degree clock input
--      CE => '1',    -- Clock enable input
--      D0 => TTC_toggle,    -- Posedge data input
--      D1 => TTC_toggle,    -- Negedge data input
--      R => '0',      -- Synchronous reset input
--      S => '0'       -- Synchronous preset input
--   );
--i_TTC_clk_DDR_out1 : OFDDRRSE
--   port map (
--      Q => TTC_clk_IO(1),      -- Data output (connect directly to top-level port)
--      C0 => ttc_clk,    -- 0 degree clock input
--      C1 => ttc_clk_n,    -- 180 degree clock input
--      CE => '1',    -- Clock enable input
--      D0 => TTC_toggle,    -- Posedge data input
--      D1 => TTC_toggle,    -- Negedge data input
--      R => '0',      -- Synchronous reset input
--      S => '0'       -- Synchronous preset input
--   );
--ttc_clk_n <= not ttc_clk;
i_TTC_clk_DDR_in0 : IFDDRRSE
   port map (
      Q0 => ttc_clk0,    -- Posedge data output
      Q1 => ttc_clk180,    -- Negedge data output
      C0 => rx_clk,    -- 0 degree clock input
      C1 => rx_clk180,    -- 180 degree clock input
      CE => '1',    -- Clock enable input
      D => TTC_clk_IO(0),      -- Data input (connect directly to top-level port)
      R => '0',      -- Synchronous reset input
      S => '0'       -- Synchronous preset input
   );
rx_clk180 <= not rx_clk;
i_TTC_clk_DDR_in1 : IFDDRRSE
   port map (
      Q0 => ttc_clk90,    -- Posedge data output
      Q1 => ttc_clk270,    -- Negedge data output
      C0 => rx_clk90,    -- 0 degree clock input
      C1 => rx_clk270,    -- 180 degree clock input
      CE => '1',    -- Clock enable input
      D => TTC_clk_IO(1),      -- Data input (connect directly to top-level port)
      R => '0',      -- Synchronous reset input
      S => '0'       -- Synchronous preset input
   );
rx_clk270 <= not rx_clk90;


end Behavioral;

